#!/home/stettberger/bin/haserl -s /bin/bash
<? source ./rc 
   source ./common.sh

if [ -n "$FORM_save" ]; then
  if [ "x$FORM_password" = "x$PASSWORD" ]; then
    mkdir -p `dirname "$DATADIR/$FORM_path"`
    if [ ! -e "$DATADIR/$FORM_path" ]; then git_action=add; fi
    if ! echo -n "$FORM_text" > "$DATADIR/$FORM_path"; then
      content() { error "Permission denied. Please inform Administrator"; }
      render_immediate=true
    else
      ( cd $DATADIR; git ${git_action:-update-index} ".$FORM_path";
        git commit -n -m "${FORM_commit_msg:-${git_action:-Modification} of $FORM_path}";)
      format_page <<< "$FORM_text" > "$DATADIR/$FORM_path.cache"
      redirect "${SCRIPT_NAME/%edit.sh/show.sh}?path=$FORM_path"
    fi
  else
    content() { error "Wrong password"; }
    render_immediate=true
  fi
fi ?>Content-Type: text/html

<? if [ -n "$render_immediate" ]; then ?>
<?in ./tmpl ?>
<? exit; fi 

escape() { sed 's/&/\&amp/g; s/</\&lt;/g; s/>/\&gt;/g' $1 ; }
content() {
  PATH_INFO="$(path_r "$(getpath)")"
  if [ -d "$DATADIR/$PATH_INFO" ]; then 
    error "$PATH_INFO is a directory"
    return
  fi
  if [ -n "$FORM_text" ]; then
      echo "<h1>Preview:</h1><div class='container'>`format_page <<< "$FORM_text"`</div>"
  fi
  echo "<div class='container'><h1>$PATH_INFO</h1>"
  echo -n "<form action='`echo -n $SCRIPT_NAME`' method='POST'>
    <textarea name='text' id='text' cols='80' rows='30'>"
  if [ -n "$FORM_text" ]; then
    escape <<< "$FORM_text"
  elif [ -f "$DATADIR/$PATH_INFO" ]; then 
    if [ -n "$FORM_id" ]; then
      get_git_blob "$FORM_id" "${PATH_INFO#/}" | escape 
    else
      escape < "$DATADIR/$PATH_INFO"
    fi
  fi
  echo "</textarea><p>Commit Message: <input type='text' name='commit_msg' size='30'></p> 
  Password: <input type='password' name='password'><input type='submit' name='save' value='Save'>
  <span style='position: relative; left: 40px'><input type='submit' name='preview' value='Preview'></span>
  <input type='hidden' name='path' value='$PATH_INFO'></form></div>
  <div id='ctrlmenu'><a href='${SCRIPT_NAME/%edit.sh/show.sh}?path=$PATH_INFO'>Show</a></div>"
}
?>
<?in ./tmpl ?>
