#!/home/stettberger/bin/haserl -s /bin/bash
<? source ./rc 
   source ./common.sh 
PATH_INFO="$(path_r "$(getpath)")"
first=$(line < "$DATADIR/$PATH_INFO")
if [ -n "$FORM_raw" ]; then
  MIME=`file -i "$DATADIR/$PATH_INFO"`?>Content-Type: <? echo -en "${MIME#*:}\n\n"?>

<? cat "$DATADIR/$PATH_INFO"
  exit
elif [ -n "`expr match \"$first\" '\(#redirect \)'`" ]; then
  redirect "${first#* }"
elif [ -n "`expr match \"$first\" '\(#raw \)'`" ]; then
  redirect "${SCRIPT_NAME}?raw=1&path=${first#* }"
elif [ -n "`expr match \"$first\" '\(#goto \)'`" ]; then
  redirect "${SCRIPT_NAME}?path=${first#* }"
fi

list_path() {
  if [ ! -d "$DATADIR${1}" -o -z "`ls $DATADIR${1}`" ]; then return; fi 
  echo "<ul>"
  for item in $(ls -F "$DATADIR${1}" | sort); do
    if [ -n "`expr match \"$item\" '.*\(\.cache\)'`" ]; then continue; fi
    tmp_path="$1$item"
    tmp_path=${tmp_path/%\//}/
    if [ `expr match "$PATH_INFO/" "$tmp_path"` -eq ${#tmp_path} ]; then
      if [ -f "$DATADIR${1}$item" ]; then
        echo "<strong><li>${item#*_}</li></strong>"
      else
        echo "<li>$item</li>"
      fi
      list_path "${1}$item"
    else
      echo "<li><a href='$SCRIPT_NAME?path=${1}$item'>${item#*_}</a></li>"
    fi
  done
  echo "</ul>"
}

content() {
  echo "<div id='menu'>`list_path /`</div>"
  echo "<div id='page'>"
  if [ ! -f $DATADIR/$PATH_INFO ]; then
    error "Page $PATH_INFO doesn't exist or is a directory"
  else
    if [ "$DATADIR/$PATH_INFO.cache" -nt "$DATADIR/$PATH_INFO" ]; then
      cat "$DATADIR/$PATH_INFO.cache"
    else
      format_page "$DATADIR/$PATH_INFO" | tee "$DATADIR/$PATH_INFO.cache"
    fi
  fi
  echo "</div><div id='ctrlmenu'>"
  if [ ! -d $DATADIR/$PATH_INFO ]; then
    echo "<a href='${SCRIPT_NAME/%show.sh/edit.sh}?path=$PATH_INFO'>Edit</a>"
    echo "<a href='${SCRIPT_NAME/%show.sh/history.sh}?path=$PATH_INFO'>History</a>"
  fi
  echo "<a href='${SCRIPT_NAME/%show.sh/remove.sh}?path=$PATH_INFO'>Remove</a></div>"
}
?>Content-Type: text/html

<?in ./tmpl ?>
